#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#define SZ(x) (sizeof(x)/(sizeof(*x)))
typedef float (*Ciag_f)(float, float, float);

typedef struct {
  Ciag_f f;
  char *nazwa;
  char *wzor;
  char *argn;
} Ciag;

float
af(float n, float r, float a1)
{
  return a1 + (n-1)*r;
}

float
gf(float n, float q, float a1)
{
  return a1 * pow(q, n-1);
}

float
hf(float n, float __attribute__((unused)) q, float a1)
{
  return 1.f/(a1+n-1);
}

float
kf(float n, float __attribute__((unused)) q, float a1)
{
  return pow(a1+n-1, 2);
}

float
sf(float n, float __attribute__((unused)) q, float a1)
{
  return pow(a1+n-1, 3);
}

float
tf(float n, float __attribute__((unused)) q, float a1)
{
  return ((a1+n-1)*(a1+n))/2;
}

float
mf(float n, float __attribute__((unused)) q, float a1)
{
  return pow(a1+n-1, 2)-1;
}


void
licz(Ciag *c)
{
  char sa1[512] = {0}, sr[512] = {0};

  printf("%s o wzorze %s\n", c->nazwa, c->wzor);
  printf("podaj a1: ");
  scanf("%s", sa1);

  if (c->argn) {
    printf("podaj %s: ", c->argn);
    scanf("%s", sr);
  }

  int i;
  int a1 = atoi(sa1);
  int r = atoi(sr);

  for (i = 1; i <= 40; ++i) {
    printf("a%d = %.2f\n", i, c->f(i, r, a1));
  }

  double sum10 = 0.f;
  for (i = 1; i <= 10; ++i) {
    sum10 += c->f(i, r, a1);
  }

  printf("\nS10 = %.2lf\n\n", sum10);
}

int
main(void)
{
  Ciag ciagi[] = {
    (Ciag) {
      .f = af,
      .nazwa = "Ciąg arytmetyczny",
      .wzor = "an = a1 + (n - 1) * r",
      .argn = "r"
    },
    (Ciag) {
      .f = gf,
      .nazwa = "Ciąg geometryczny",
      .wzor = "an = a1 * q^(n-1)",
      .argn = "q"
    },
    (Ciag) {
      .f = hf,
      .nazwa = "Ciąg harmoniczny",
      .wzor = "an = 1/(a1+n-1)",
      .argn = NULL
    },
    (Ciag) {
      .f = kf,
      .nazwa = "Ciąg kwadratowy",
      .wzor = "an = (a1+n-1)^2",
      .argn = NULL
    },
    (Ciag) {
      .f = sf,
      .nazwa = "Ciąg sześcienny",
      .wzor = "an = (a1+n-1)^3",
      .argn = NULL
    },
    (Ciag) {
      .f = tf,
      .nazwa = "Ciąg trójkątny",
      .wzor = "an = ((a1+n-1)*(a1+n))/2",
      .argn = NULL
    },
    (Ciag) {
      .f = mf,
      .nazwa = "Ciąg Mersenne'a",
      .wzor = "an = 2^(a1+n-1)-1",
      .argn = NULL
    },
  };

  int i, n;

  for (;;) {
    for (i = 0; i < (signed)SZ(ciagi); ++i)
      printf("%d. %s\n", i+1, ciagi[i].nazwa);

    printf("wybierz ciąg: ");
    scanf("%d", &n);

    licz(&ciagi[n-1]);
  }


  // dla innego wzoru wystarczy zdefiniować i wypełnić strukturę `Ciag'
  return 0;
}

